function Td=flexiblediv(T,f)
%FLEXIBLEDIV - flexible division for triangle
%call Td=flexiblediv(T,f)
%T - initial trinagle
%f - the function
%Td - resulted triangles

global q rho1 rho2 
%compute sides
a=T(:,1)-T(:,2); ha=norm(a);
b=T(:,2)-T(:,3); hb=norm(b);
c=T(:,3)-T(:,1); hc=norm(c);
sides=[1,2,3;2,3,1;3,1,2];
C=(sum(T'))'/3;
fC=f(C);
DD(1)=D(a,ha,C,f,fC);
DD(2)=D(b,hb,C,f,fC);
DD(3)=D(c,hc,C,f,fC);
%reorder the sides
[D,is]=sort(DD,'descend');

sides=sides(is,:);
Da=DD(1); Db=DD(2); Dc=DD(3);
if Dc >= Da/rho1
    Td=S1(T);
elseif Db < Da/rho2
    Td=S4(T,sides);
elseif Dc >= Da/rho2
    Td=S2(T,sides);
else
    Td=S3(T,sides);
end

% function Td=S1(T,sides)
% %type S1 subdivision (congruent)
% M1=(T(:,2)+T(:,3))/2;
% M2=(T(:,1)+T(:,3))/2;
% M3=(T(:,1)+T(:,2))/2;
% Td=zeros(2,12);
% Td=[T(:,1),M3,M2, M3,T(:,2),M1, M2,M1,T(:,3), M1, M2,M3];
% disp('S1')
% 
% function Td=S2(T,sides)
% %type S2 subdivision 
% %call Td=S2(T,sides);
% 
% T1=T(:,sides(1,1)); T2=T(:,sides(1,2)); T3=T(:,sides(1,3));
% M1=(T1+T2)/2;
% M2=(T(:,sides(2,1))+T(:,sides(2,2)))/2;
% M3=(T(:,sides(3,1))+T(:,sides(3,2)))/2;
% Td=zeros(2,12);
% if sides(1,2)~=sides(2,1)
%     adT1=M2; adT2=M3;
% else
%     adT1=M3; adT2=M2;
% end
% %order first a
% Td=[T1,M1,adT1, M1,adT1,T3, M1,adT2,T3, M1,adT2,T2];
% disp('S2')
% 
% function Td=S3(T,sides)
% %type S3 subdivision
% 
% T1=T(:,sides(2,3)); 
% if sides(2,3)==sides(1,1)
%     T2=T(:,sides(1,2)); 
% else
%     T2=T(:,sides(1,1));
% end
% T3=T(:,sides(1,3));
% M1=2/3*T(:,sides(1,1))+1/3*T(:,sides(1,2));
% M2=(T(:,sides(2,1))+T(:,sides(2,2)))/2;
% Td=zeros(2,9);
% Td=[T1,M1,T3, M1,T3,M2, M1,M2,T2];
% disp('S3')
% 
% 
% function Td=S4(T,sides)
% %type S4 subdivision
% 
% T1=T(:,sides(1,1)); T2=T(:,sides(1,2)); T3=T(:,sides(1,3));
% M1=2/3*T(:,sides(1,1))+1/3*T(:,sides(1,2));
% M2=1/3*T(:,sides(1,1))+2/3*T(:,sides(1,2));
% Td=zeros(2,9);
% Td=[T1,M1,T3, M1,M2,T3, M2,T2,T3];
% disp('S4')


function y=D(e,h,C,f,fC)
%compute measure of variation of f along an edge
global q
y=h^q*abs(f(C-4/15*h*e)-4*f(C-2/15*h*e)+6*fC-4*f(C+2/15*h*e)+f(C+4/15*h*e));
